/*******************************************************************************
 * Copyright (c) 2003, 2004 Rick Ohnuki. All rights reserved.
 * 
 * This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 * (http://opensource.org/licenses/cpl.php)
 * 
 * You must not remove this notice, or any other, from this software
 * 
 * Contributors:
 *     Rick Ohnuki - initial API and implementation
 *******************************************************************************/

package latte.action;

import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.uml2.Property;

import latte.Latte;
import latte.di.GraphEdge;
import latte.util.ModelUtil;


/**
 * 
 * @version $Id: NavigableAction.java,v 1.1 2004/09/11 12:43:39 ohnuki Exp $
 * @author $Author: ohnuki $
 */
public class NavigableAction extends AbstractLatteAction {

    public NavigableAction(String title, String imageFile) {
        super(title, imageFile);
    }
 
    /**
     * irQ[^uL
     * @param param
     */
    public void execMain(Object param) {
        // 
        SelectionEvent se = (SelectionEvent)param;
        MenuItem menuItem = (MenuItem)se.getSource();
        // 
        GraphEdge graphEdge = (GraphEdge)Latte.getMainForm().getSelectedModels();
        Property property = ModelUtil.getFromProperty(graphEdge);

        // irQ[^uݒFL聨LA
        if (menuItem.getSelection()) {
            property.setNavigable(true);
        } else {
            property.setNavigable(false);
        }
        
        // t@CۑKv
        ModelUtil.setNeedSaving();     
    }
}
